#include "cryptlib.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int main() {

	FILE *file;
	char buffer[1000];
	int p;
	int bytesCopied;
	CRYPT_ENVELOPE cryptEnvelope;
	CRYPT_ENVELOPE cryptEnvelope2;
	
	file = fopen("testfile", "rb");
	if(!file)return 1;
	p=fread(buffer,1,9999,file);
	if(!p) return 1;
	fclose(file);
	
	buffer[p] = 0;
	
	cryptInit();
 	cryptCreateEnvelope( &cryptEnvelope, CRYPT_UNUSED, CRYPT_FORMAT_CRYPTLIB );
	cryptSetAttributeString( cryptEnvelope, CRYPT_ENVINFO_PASSWORD, "password", 8);
	cryptPushData(cryptEnvelope, buffer, p, &bytesCopied);
	cryptFlushData(cryptEnvelope);
	cryptPopData(cryptEnvelope, buffer, 10000, &bytesCopied);		
	cryptDestroyEnvelope( cryptEnvelope );

	file = fopen("envelopedfile", "wb");
	fwrite(buffer,1,bytesCopied,file);
	fclose(file);

	cryptCreateEnvelope( &cryptEnvelope2, CRYPT_UNUSED, CRYPT_FORMAT_AUTO);
	cryptPushData(cryptEnvelope2, buffer, bytesCopied, &bytesCopied);
	cryptSetAttributeString( cryptEnvelope2, CRYPT_ENVINFO_PASSWORD, "password", 8);
	cryptFlushData(cryptEnvelope2);
	cryptPopData(cryptEnvelope2, buffer, 10000, &bytesCopied);
	cryptDestroyEnvelope(cryptEnvelope2);

	file = fopen("denvelopedfile", "wb");
	fwrite(buffer,bytesCopied,1,file);
	fclose(file);

	cryptEnd();
	
}
